package org.jboss.qa.staxsource;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import org.codehaus.jackson.annotate.JsonIgnore;

@XmlRootElement(name="item", namespace="urn:jboss-soa:order-service:1.0")
@XmlAccessorType(XmlAccessType.FIELD)
public class OrderItem implements Serializable {

    private static final long serialVersionUID = 8092646868646963278L;

    @XmlAttribute
    Long sku;
    @XmlElement(namespace="urn:jboss-soa:order-service:1.0")
    Integer count;
    @XmlElement(namespace="urn:jboss-soa:order-service:1.0")
    Double pricePerUnit;

    public OrderItem() {
    }

    public OrderItem(Long sku, Integer count, Double pricePerUnit) {
        this.sku = sku;
        this.count = count;
        this.pricePerUnit = pricePerUnit;
    }

    public Long getSku() {
        return sku;
    }

    public void setSku(Long sku) {
        this.sku = sku;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    public Double getPricePerUnit() {
        return pricePerUnit;
    }

    public void setPricePerUnit(Double pricePerUnit) {
        this.pricePerUnit = pricePerUnit;
    }

    @JsonIgnore
    public BigDecimal getTotalPrice() {
        return new BigDecimal(pricePerUnit).multiply(new BigDecimal(count));
    }

    @Override
    public String toString() {
        return "OrderItem [sku=" + getSku() + ", count=" + getCount() + ", pricePerUnit=" + getPricePerUnit() + "]";
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((pricePerUnit == null) ? 0 : pricePerUnit.hashCode());
        result = prime * result + ((sku == null) ? 0 : sku.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        OrderItem other = (OrderItem) obj;
        if (pricePerUnit == null) {
            if (other.pricePerUnit != null) {
                return false;
            }
        } else if (!pricePerUnit.equals(other.pricePerUnit)) {
            return false;
        }
        if (sku == null) {
            if (other.sku != null) {
                return false;
            }
        } else if (!sku.equals(other.sku)) {
            return false;
        }
        return true;
    }
}
